/**
 * 
 */
/**
 * @author dasheng
 *
 */
package com.baofoo.Demo;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;

import net.sf.json.JSONObject;

/**
 * 银行卡验证
 * @author dasheng
 *
 */
public class Bankcard{
	
	public static void main(String[] args) throws Exception{
		String member_id = "100026286";
		String terminal_id = "200001418";
		
		String card_type = "102";//借记卡:101，	信用卡:102
		String acc_no="6217258856786677";
		String id_card="320300199110093132";
		String id_holder="陈光辉";
		String mobile = "18689262779";
		
		String valid_date="";//(非信用卡传空)信用卡有效期，如：0117（月+年）
		String valid_no = "";//(非信用卡传空)信用卡背面3位数字检验码，如：123
		String verify_element="1234";//123:三要素（银行卡号 + 姓名 + 身份证号）,	1234:四要素（银行卡号 + 姓名 + 身份证号 + 银行卡预留手机号）
	
		String  pfxpath ="D:\\CER_EN_DECODE\\100026286\\bfkey_100026286@@200001418.pfx";//商户私钥        
        String  cerpath ="D:\\CER_EN_DECODE\\100026286\\bfkey_100026286@@200001418.cer";//宝付公钥
		String pfxpwd = "100026286_715265";//私钥密码
		
		Map<String,String> PostHeadMap = new TreeMap<String,String>();
	
		PostHeadMap.put("member_id", member_id);
		PostHeadMap.put("terminal_id", terminal_id);//报文流水号
		PostHeadMap.put("data_type", "json");
		
		Map<String,String> datacontent = new TreeMap<String,String>();
		
		datacontent.put("member_id",member_id);
		datacontent.put("terminal_id",terminal_id);
		datacontent.put("trans_id","TID"+System.currentTimeMillis());//商户订单号（自定义订单号）
		datacontent.put("trade_date",new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()));
		datacontent.put("acc_no",acc_no);
		datacontent.put("id_card",id_card);
		datacontent.put("id_type","0");//0:身份证,1:军官证,2:护照
		datacontent.put("id_holder",id_holder);
		datacontent.put("card_type",card_type);//借记卡:101，	信用卡:102
		datacontent.put("mobile",mobile);
		datacontent.put("industry_type","A1");
		datacontent.put("valid_date",valid_date);
		datacontent.put("valid_no",valid_no);
		datacontent.put("verify_element",verify_element);
		datacontent.put("product_type","0");
		
		String DcStr=JSONObject.fromObject(datacontent).toString();
		Log.Write("业务请求参数："+DcStr);
		
		String base64str = SecurityUtil.Base64Encode(DcStr);
		String En_DcStr = RsaCodingUtil.encryptByPriPfxFile(base64str,pfxpath,pfxpwd);
		
		
		PostHeadMap.put("data_content", En_DcStr);//放入业务请求参数。
		
		String restr = HttpUtil.RequestForm("https://vgw.baofoo.com/biztransfer/bankcard/v3/auth", PostHeadMap);
		JSONObject jsonObject = JSONObject.fromObject(restr);
		
		if(!jsonObject.containsKey("success")){
			throw new Exception("返回异常");
		}
		
		if(Boolean.parseBoolean(jsonObject.get("success").toString())){
			if(!jsonObject.containsKey("data")){
				throw new Exception("返回异常");
			}
			
			JSONObject sonJsonObj = (JSONObject) jsonObject.get("data");
			
			Log.Write("返回数据："+sonJsonObj.toString());
		}
		
		
		Log.Write("返回数据："+restr);
		
	}	
} 